//----------------------------------------------------------------------//
// NyanFi																//
//  eLXgrA[̔zF												//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "ColDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TColorDlg *ColorDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TColorDlg::TColorDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::FormCreate(TObject *Sender)
{
	ObjViewer = NULL;

	ColBufList = new TStringList();

	ColorListBox->Items->Text =
		"bgView=wiF\n"
		"fgView=F\n"
		"Margin=]\n"
		"bgRuler=[̔wiF\n"
		"fgRuler=[̖ڐF\n"
		"Cursor=CJ[\̐F\n"
		"selItem=Iڂ̔wiF\n"
		"fgSelItem=Iڂ̕F\n"
		"bgLineNo=sԍwiF\n"
		"LineNo=sԍF\n"
		"Mark=s}[N\n"
		"bdrLine=sԍE\n"
		"bdrFold=܂ԂE\n"
		"bdrFixed=Œ蒷\̏cr\n"
		"Comment=|Rg̕F\n"
		"Strings=̕F\n"
		"Reserved=\̕F\n"
		"Symbol=V{̕F\n"
		"Numeric=l̕F\n"
		"fgEmpBin1=oCiF1\n"
		"fgEmpBin2=oCiF2\n"
		"fgEmpBin3=oCiF3\n"
		"Headline=o̕F\n"
		"Ruby=r\n"
		"URL=URL̕F\n"
		"LocalLink=[Jt@Cւ̃N\n"
		"fgEmp=F\n"
		"bgEmp=wiF\n"
		"TAB=^u\F\n"
		"CR=s\F\n"
		"HR=r̐F\n"
		"Ctrl=Rg[R[h\n"
		"Folder=fBNg̕F\n"
		"Error=G[̕F\n";

	SwatchPanel = new UsrSwatchPanel(this);
	SwatchPanel->Parent = this;
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::FormShow(TObject *Sender)
{
	if (!ObjViewer) ObjViewer = TxtViewer;

	SwatchPanel->SetPanelSize16x8(15);
	SwatchPanel->Left = ClientWidth  - SwatchPanel->Width;
	SwatchPanel->Top  = ClientHeight - SwatchPanel->Height;

	set_ListBoxItemHi(ColorListBox);

	ColBufList->Assign(ObjViewer->ColBufList);

	SetDarkWinTheme(this);
	ColorListBox->Color = IsDarkMode? dcl_Window : scl_Window;
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	ObjViewer = NULL;
	FileName  = EmptyStr;
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::FormDestroy(TObject *Sender)
{
	delete ColBufList;
}

//---------------------------------------------------------------------------
//ꗗ̕`
//---------------------------------------------------------------------------
void __fastcall TColorDlg::ColorListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
	TOwnerDrawState State)
{
	draw_ColorListBox((TListBox*)Control, Rect, Index, State, ColBufList);
}

//---------------------------------------------------------------------------
//F̎Q
//---------------------------------------------------------------------------
void __fastcall TColorDlg::RefColBtnClick(TObject *Sender)
{
	TListBox *lp = ColorListBox;
	int idx = lp->ItemIndex;	if (idx==-1) return;

	UnicodeString col_nam = lp->Items->Names[idx];
	UserModule->ColorDlg->Color = (TColor)ColBufList->Values[col_nam].ToIntDef(clBlack);
	if (UserModule->ColorDlg->Execute()) {
		ColBufList->Values[col_nam] = IntToStr(UserModule->ColorDlg->Color);
		lp->Repaint();
	}
}

//---------------------------------------------------------------------------
//X|Cg
//---------------------------------------------------------------------------
void __fastcall TColorDlg::SpuitImageMouseDown(TObject *Sender, TMouseButton Button,
		TShiftState Shift, int X, int Y)
{
	TListBox *lp = ColorListBox;
	if (Button!=mbLeft || lp->ItemIndex==-1) return;

	//XEHb`ubN
	SetCustomColToSwatch(UserModule->ColorDlg->CustomColors);
	SwatchPanel->Visible = true;
	SwatchPanel->BringToFront();

	TColor col_def = (TColor)ColBufList->Values[lp->Items->Names[lp->ItemIndex]].ToIntDef(clNone);
	UserModule->BeginSpuit(SpuitPanel, SpuitImage, col_def);
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::SpuitImageMouseUp(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
	SwatchPanel->Visible = false;

	if (UserModule->SpuitEnabled()) {
		TColor col = UserModule->EndSpuit();
		TListBox *lp = ColorListBox;
		if (lp->ItemIndex!=-1) {
			ColBufList->Values[lp->Items->Names[lp->ItemIndex]] = col;
			lp->Repaint();
		}
	}
}

//---------------------------------------------------------------------------
//C|[g
//---------------------------------------------------------------------------
void __fastcall TColorDlg::InportBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("zF̃C|[g"), F_FILTER_INI, _T("*.INI"));
	UnicodeString fnam = UserModule->OpenDlgExecute();
	if (!fnam.IsEmpty()) {
		std::unique_ptr<UsrIniFile> inp_file(new UsrIniFile(fnam));
		inp_file->ReadSection("Color", ColBufList);
		ColorListBox->Repaint();
	}
	SetFocus();
}
//---------------------------------------------------------------------------
//GNX|[g
//---------------------------------------------------------------------------
void __fastcall TColorDlg::ExportBtnClick(TObject *Sender)
{
	UserModule->PrepareSaveDlg(_T("zF̃GNX|[g"), F_FILTER_INI, FileName.c_str());
	UnicodeString fnam = UserModule->SaveDlgExecute();
	if (!fnam.IsEmpty()) {
		std::unique_ptr<UsrIniFile> exp_file(new UsrIniFile(fnam));
		exp_file->AssignSection("Color", ColBufList);
		if (!exp_file->UpdateFile(true)) msgbox_ERR(USTR_FaildSave);
	}
	SetFocus();
}
//---------------------------------------------------------------------------
//Ŝɔf
//---------------------------------------------------------------------------
void __fastcall TColorDlg::OptApplyBtnClick(TObject *Sender)
{
	if (msgbox_Sure(_T("Ŝ̃IvVݒɔf܂H"))) {
		ObjViewer->SetColor(ColBufList);
		ObjViewer->SetOptColor();
		ObjViewer->Repaint(true);
	}
}
//---------------------------------------------------------------------------
//Kp
//---------------------------------------------------------------------------
void __fastcall TColorDlg::ApplyBtnClick(TObject *Sender)
{
	ObjViewer->SetColor(ColBufList);
	ObjViewer->Repaint(true);
}

//---------------------------------------------------------------------------
//m
//---------------------------------------------------------------------------
void __fastcall TColorDlg::OkActionExecute(TObject *Sender)
{
	ObjViewer->SetColor(ColBufList);
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::OkActionUpdate(TObject *Sender)
{
	if (!UserModule->SpuitEnabled()) SpuitImage->Visible = (ColorListBox->ItemIndex!=-1);
}

//---------------------------------------------------------------------------
//LZ
//---------------------------------------------------------------------------
void __fastcall TColorDlg::CancelBtnClick(TObject *Sender)
{
	//X|Cg̃LZ
	if (UserModule->SpuitEnabled()) {
		SwatchPanel->Visible = false;
		UserModule->EndSpuit();
		SpuitImage->Visible = true;
	}
	//
	else {
		ModalResult = mrCancel;
	}
}

//---------------------------------------------------------------------------
//zF̖
//---------------------------------------------------------------------------
void __fastcall TColorDlg::DisableColActionExecute(TObject *Sender)
{
	TListBox *lp = ColorListBox;
	if (lp->ItemIndex!=-1) {
		ColBufList->Values[lp->Items->Names[lp->ItemIndex]] = IntToStr(clNone);
		lp->Invalidate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::DisableColActionUpdate(TObject *Sender)
{
	TListBox *lp = ColorListBox;
	UnicodeString col_id = (lp->ItemIndex!=-1)? lp->Items->Names[lp->ItemIndex] : EmptyStr;
	((TAction*)Sender)->Enabled = contained_wd_i(_T("fgSelItem|bdrLine|bdrFold|bdrFixed"), col_id);
}

//---------------------------------------------------------------------------
//wv
//---------------------------------------------------------------------------
bool __fastcall TColorDlg::FormHelp(WORD Command, NativeInt Data, bool &CallHelp)
{
	if (Command==HELP_CONTEXT || Command==HELP_CONTEXTPOPUP) {
		HtmlHelpTopic(_T(HELPTOPIC_TV) _T("#SetColor"));
		CallHelp = false;
	}
	return true;
}
//---------------------------------------------------------------------------

